<template>
  <b-modal
    ref="modal"
    centered
    @hide="onHide"
  >
    <p>{{ message }}</p>
    <p>
      Please enter <code>{{ confirmValue }}</code> below to continue.
    </p>
    <b-form-input v-model="value" />
    <template #modal-footer>
      <b-button @click="reject">
        Cancel
      </b-button>
      <b-button
        :disabled="$v.confirmValue.$invalid"
        :variant="variant"
        @click="confirm"
      >
        Confirm
      </b-button>
    </template>
  </b-modal>
</template>

<script lang="ts">
/* eslint-disable @typescript-eslint/no-empty-function */
import Vue from 'vue';
import { BModal, BvModalEvent } from 'bootstrap-vue';
import { sameAs } from 'vuelidate/lib/validators';

export default Vue.extend({
  props: {
    variant: {
      default: 'danger',
      type: String,
    },
  },

  data() {
    return {
      confirmValue: '',
      message: '',
      resolve: (() => {}) as (value: boolean) => void,
      value: '',
    };
  },

  validations: {
    confirmValue: {
      sameAsValue: sameAs('value'),
    },
  },

  methods: {
    reset() {
      this.value = '';
      this.confirmValue = '';
      this.message = '';
      this.resolve = () => {};
    },

    prompt(message: string, confirmValue: string) {
      this.message = message;
      this.confirmValue = confirmValue;
      (this.$refs.modal as BModal).show();
      return new Promise((resolve) => {
        this.resolve = resolve;
      });
    },

    confirm() {
      (this.$refs.modal as BModal).hide('ok');
    },

    reject() {
      (this.$refs.modal as BModal).hide('cancel');
    },

    onHide(event: BvModalEvent) {
      this.resolve(event.trigger === 'ok');
      this.reset();
    },
  },
});
</script>

<style scoped></style>
